package com.zhn.decode.config;

import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttConnectOptions;
import org.eclipse.paho.client.mqttv3.MqttException;
import org.eclipse.paho.client.mqttv3.persist.MemoryPersistence;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * MQTT配置类，用于创建并配置MQTT客户端。
 *
 * @author Administrator
 */
@Configuration
public class MqttConfig {
	
	/**
	 * MQTT代理服务器地址和端口。
	 */
	private static final String BROKER = "tcp://fluxmq.muyu.icu:1883";
	
	/**
	 * MQTT客户端ID。
	 */
	private static final String CLIENT_ID = "mqttx_12345";
	
	/**
	 * MQTT主题名称。
	 */
	
	
	/**
	 * 创建并配置MQTT客户端。
	 *
	 * @return MQTT客户端实例
	 *
	 * @throws MqttException 如果连接到MQTT代理服务器失败
	 */
	@Bean
	public MqttClient mqttClient () throws MqttException {
		
		MqttClient client = new MqttClient (BROKER, CLIENT_ID, new MemoryPersistence ());
		MqttConnectOptions options = new MqttConnectOptions ();
		options.setCleanSession (true);
		client.connect (options);
		System.out.println ("开始连接");
		
		return client;
	}
}
