package com.zhn.decode.service.impl;

import com.zhn.decode.domain.VehicleData;
import lombok.extern.log4j.Log4j;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.stereotype.Service;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;

@Service
@Log4j
public class ConsumerService {
	// 定义 TiDB 连接信息
	private static final String TIDBURL = "jdbc:mysql://123.207.204.152:4000/test";
	private static final String USERNAME = "root";
	private static final String PASSWORD = "123456";
	
	@KafkaListener (topics = "mqttAA", groupId = "Fluxmq_consumer")
	public void listen (ConsumerRecord<String, byte[]> record) {
		String message = new String (record.value ());
		StringBuilder sb = new StringBuilder ();
		String[] arr = message.split (" ");
		for (String s : arr) {
			int ch = Integer.parseInt (s, 16);
			sb.append ((char) ch);
		}
		VehicleData build = VehicleData.getBuild (sb.toString ());
		try (Connection connection = DriverManager.getConnection (TIDBURL, USERNAME, PASSWORD)) {
			String sql = """
					INSERT INTO vehicle_data (
					                                 vin,
					                                 create_time,
					                                 longitude,
					                                 latitude,
					                                 speed,
					                                 mileage,
					                                 voltage,
					                                 current,
					                                 resistance,
					                                 gear,
					                                 acceleration_pedal,
					                                 brake_pedal,
					                                 fuel_consumption_rate,
					                                 motor_controller_temperature,
					                                 motor_speed,
					                                 motor_torque,
					                                 motor_temperature,
					                                 motor_voltage,
					                                 motor_current,
					                                 remaining_battery,
					                                 maximum_feedback_power,
					                                 maximum_discharge_power,
					                                 self_check_counter,
					                                 total_battery_current,
					                                 total_battery_voltage,
					                                 single_battery_max_voltage,
					                                 single_battery_min_voltage,
					                                 single_battery_max_temperature,
					                                 single_battery_min_temperature,
					                                 available_battery_capacity,
					                                 vehicle_status,
					                                 charging_status,
					                                 operating_status,
					                                 soc_status,
					                                 charging_energy_storage_status,
					                                 drive_motor_status,
					                                 position_status,
					                                 eas_status,
					                                 ptc_status,
					                                 eps_status,
					                                 abs_status,
					                                 mcu_status,
					                                 heating_status,
					                                 battery_status,
					                                 battery_insulation_status\s
					                                )
					                                VALUES
					                                 (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)""";
			try (PreparedStatement preparedStatement = connection.prepareStatement (sql)) {
				// 设置参数
				preparedStatement.setString (1, build.getVin ());
				preparedStatement.setDate (2, null);
				preparedStatement.setString (3, build.getLongitude ());
				preparedStatement.setString (4, build.getLatitude ());
				preparedStatement.setString (5, build.getSpeed ());
				preparedStatement.setBigDecimal (6, build.getMileage ());
				preparedStatement.setString (7, build.getVoltage ());
				preparedStatement.setString (8, build.getCurrent ());
				preparedStatement.setString (9, build.getResistance ());
				preparedStatement.setString (10, build.getGear ());
				preparedStatement.setString (11, build.getAccelerationPedal ());
				preparedStatement.setString (12, build.getBrakePedal ());
				preparedStatement.setString (13, build.getFuelConsumptionRate ());
				preparedStatement.setString (14, build.getMotorControllerTemperature ());
				preparedStatement.setString (15, build.getMotorSpeed ());
				preparedStatement.setString (16, build.getMotorTorque ());
				preparedStatement.setString (17, build.getMotorTemperature ());
				preparedStatement.setString (18, build.getMotorVoltage ());
				preparedStatement.setString (19, build.getMotorCurrent ());
				preparedStatement.setBigDecimal (20, build.getRemainingBattery ());
				preparedStatement.setString (21, build.getMaximumFeedbackPower ());
				preparedStatement.setString (22, build.getMaximumDischargePower ());
				preparedStatement.setString (23, build.getSelfCheckCounter ());
				preparedStatement.setString (24, build.getTotalBatteryCurrent ());
				preparedStatement.setString (25, build.getTotalBatteryVoltage ());
				preparedStatement.setString (26, build.getSingleBatteryMaxVoltage ());
				preparedStatement.setString (27, build.getSingleBatteryMinVoltage ());
				preparedStatement.setString (28, build.getSingleBatteryMaxTemperature ());
				preparedStatement.setString (29, build.getSingleBatteryMinTemperature ());
				preparedStatement.setString (30, build.getAvailableBatteryCapacity ());
				preparedStatement.setInt (31, build.getVehicleStatus ());
				preparedStatement.setInt (32, build.getChargingStatus ());
				preparedStatement.setInt (33, build.getOperatingStatus ());
				preparedStatement.setInt (34, build.getSocStatus ());
				preparedStatement.setInt (35, build.getChargingEnergyStorageStatus ());
				preparedStatement.setInt (36, build.getDriveMotorStatus ());
				preparedStatement.setInt (37, build.getPositionStatus ());
				preparedStatement.setInt (38, build.getEasStatus ());
				preparedStatement.setInt (39, build.getPtcStatus ());
				preparedStatement.setInt (40, build.getEpsStatus ());
				preparedStatement.setInt (41, build.getAbsStatus ());
				preparedStatement.setInt (42, build.getMcuStatus ());
				preparedStatement.setInt (43, build.getHeatingStatus ());
				preparedStatement.setInt (44, build.getBatteryStatus ());
				preparedStatement.setInt (45, build.getBatteryInsulationStatus ());
				
				// 执行插入操作
				preparedStatement.executeUpdate ();
			}
		}
		catch (SQLException e) {
			System.out.println (e.getMessage ());
		}
	}
}
