package com.zhn.decode.service.impl;

import com.zhn.decode.config.KafkaConfig;
import com.zhn.decode.config.MqttConfig;
import org.eclipse.paho.client.mqttv3.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;
import java.util.Arrays;

/**
 * @author : Administrator
 * @description : 分流平台服务
 */
@Service
public class ShuntModuleService {
	
	@Autowired
	KafkaConfig kafkaClient;
	@Autowired
	MqttConfig mqttClient;
	
	/** mqtt持续拉 */
	@PostConstruct
	public void mqttPush () throws MqttException {
		MqttClient client = mqttClient.mqttClient ();
		client.subscribe ("mqttAA", 1);
		client.setCallback (new MqttCallback () {
			/** 连接丢失 */
			@Override
			public void connectionLost (Throwable throwable) {
			
			}
			
			/** 消息已到达 */
			
			@Override
			public void messageArrived (String topic, MqttMessage mqttMessage) throws Exception {
				/** kafka持续推 */
				
				kafkaClient.kafkaTemplate ().send ("mqttAA", mqttMessage.getPayload ());
				System.out.println (Arrays.toString (mqttMessage.getPayload ()));
				
			}
			
			/** 交货完成 */
			
			@Override
			public void deliveryComplete (IMqttDeliveryToken iMqttDeliveryToken) {
			
			}
		});
		
		
	}
	
	
}
